/*
   Demonstracny program ku kniznici SGL pre PMD 85-2A/3 BDS C kompilator.

   Subor: SGLDEMOG.C
   Autor: RomBor 09-11/2021
*/

/* ------------------------------------------------------------------------- */
#include <stdio.h>    /* standardna I/O kniznica */
#include <sgl.h>      /* SGL kniznica */
#include "sgldemo.h"  /* hlavickovy subor dema */

/* ------------------------------------------------------------------------- */
void game()
{
  int i, flg;
  char clashB1[TILE_W * SPR_H], clashB2[TILE_W * SPR_H];

  gOriginY(ORG_Y_TOP);
  gMode(MODE_NEG);
  gCls();

  gPrintPos(3, 16);
  gPrint("Toto je komplexnejia ukka pouitia funkci");
  gPrint("SGL kninice pre spritov grafiku.");

  gPrintPos(3, 40);
  gPrint("Ako je vidie, inpircia a sprity pochdzaj");
  gPrint("z hry ");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("Manic Miner");
  gMode(COLOR_0 | MODE_NEG);
  gPrint(" od ");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("VBG Software");
  gMode(COLOR_0 | MODE_NEG);
  gPrint(".");

  gPrintPos(3, 64);
  gPrint("Pohyb Manica sa ovlda pomocou klvesov -->, ");
  gPrint("<-- a Shift. Klves K11 ukon toto demo.");

  /* inicializacia pola vysiek pipnutia pri skoku Manica */
  initw(beepTab, "0,50,74,94,119,134,151,192,242,0,32,47,53,61,69");

  while (gKey(11, 1)) { /* ak nebol stlaceny klaves K11, opakuj slucku */
    gMode(COLOR_1 | MODE_NEG);
/*
    gPrintPos(5, 98);
    gPrint("Kolzie:");
*/
    gPrintPos(34, 98);
    gPrint("Ke:");
    gMode(COLOR_0 | MODE_SET);

    /* vykrelsenie miestnosti */
    drawRoom();

    /* iniciaizacia struktury Manica a jeho zobrazenie */
    manic.pManS = S_MANIC;
    manic.mI = 0;
    manic.mX = 6;
    manic.mY = 229;
    manic.mD = 0;
    manic.mS = MS_IDL;
    manic.mK = 0;
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
    calcAround();
    flgFail = FALSE;

    flg = 1;
    while (gKey(11, 1)) { /* ak nebol stlaceny klaves K11, opakuj slucku */
      flg ^= 3;

      if (flg & 1) {
        /* ziskaj obsah VRAM na pozicii Manica do 1. buffra kolizie */
        gVramBlk(manic.mX, manic.mY, (!manic.mI) ? 1 : TILE_W, SPR_H, clashB1);

        /* spracuj posun spritov Oblud */
        for (i = 0; i < sproCnt; i++)
          procSpr(&sprites[i]);

        /* ziskaj opat obsah VRAM na pozicii Manica do 2. buffra kolizie */
        gVramBlk(manic.mX, manic.mY, (!manic.mI) ? 1 : TILE_W, SPR_H, clashB2);

        /* porovnaj kolizne buffre a zvys pocet kolizii, ak ku nej doslo */
        if (!memcmp(clashB1, clashB2, (!manic.mI) ? SPR_H : (TILE_W * SPR_H))) {
          /*  prtClash(1); */
          endGame(TRUE);
          break;
        }
      }

      if (flg & 2) {
        /* spracuj posun posuvnych pasov */
        for (i = 0; i < sprfCnt; i++)
          procFeed(&feeds[i]);
      }

      /* spracuj posun Manica */
      if (!procManic()) {
        /*  prtClash(1); */
        endGame(TRUE);
        break;
      }

      if (keysCnt[0] == '0' && keysCnt[1] == '0') {
        endGame(FALSE);
        break;
      }
    }
  }

  gMode(COLOR_0 | MODE_NEG);
  gCls();
}
/* ------------------------------------------------------------------------- */
void procSpr(s)
  struct SPRO *s;
{
  if (!s->pOblS) {
    /* prve zobrazenie spritu */
    s->pOblS = (s->oD) ? (s->pOblD + 192) : s->pOblD;
    s->oI = 0;
    gSprite(s->oX, s->oY, TILE_W, SPR_H, MODE_NEG, s->pOblS);
    return;
  }

  /* skry sprite */
  gSprite(s->oX, s->oY, TILE_W, SPR_H, MODE_NEG, s->pOblS);

  s->oI++;
  if (s->oI == 6) {
    s->oI = 0;
    if (s->oD) {
      if (s->oX == s->oXmin) {
        s->oD = 0;
        s->pOblS = s->pOblD;
      }
      else {
        s->oX--;
        s->pOblS = s->pOblD + 192;
      }
    }
    else {
      if (s->oX == s->oXmax) {
        s->oD = 1;
        s->pOblS = s->pOblD + 192;
      }
      else {
        s->oX++;
        s->pOblS = s->pOblD;
      }
    }
  }
  else
    s->pOblS += 32;

  /* zobraz sprite */
  gSprite(s->oX, s->oY, TILE_W, SPR_H, MODE_NEG, s->pOblS);
}
/* ------------------------------------------------------------------------- */
void procFeed(s)
  struct SPRF *s;
{
  int i, d;

  d = s->fI & 0x80;
  i = s->fI & 0x7F;
  if (d) {
    i--;
    if (i < 0)
      i = 3;
  }
  else {
    i++;
    if (i > 3)
      i = 0;
  }
  s->pFeedS = S_FEED1 + i * 10;
  s->fI = i | d;

  gSprite(s->fX, s->fY, TILE_W, TILE_H, MODE_SET, s->pFeedS);
}
/* ------------------------------------------------------------------------- */
int procManic()
{
  int k;

  if (manic.mS == MS_FALL) {
    if (!manFall(TRUE))
      manic.mS = MS_IDL;
    else if (!manFall(TRUE))
      manic.mS = MS_IDL;
    return (manic.mC > 0);
  }

  if (manic.mS != MS_JMP && manic.mS != MS_RJMP && manic.mS != MS_LJMP) {
    if (!manic.mI)
      k = gVramByte(manic.mX + manic.mD, manic.mY + SPR_H);
    else
      k = gVramByte(manic.mX, manic.mY + SPR_H) | gVramByte(manic.mX + 1, manic.mY + SPR_H);
    if (!k) {
      manFallI();
      return TRUE;
    }
  }

  switch (manic.mS) {
    case MS_LFT :
      k = testKbd();
      if (k != K_LFT || !manLft(TRUE))
        manic.mS = MS_IDL;
      break;

    case MS_RGH :
      k = testKbd();
      if (k != K_RGH || !manRgh(TRUE))
        manic.mS = MS_IDL;
      break;

    case MS_LJMP :
      if (!manLRJmp(manLft))
        manic.mS = MS_IDL;
      break;

    case MS_RJMP :
      if (!manLRJmp(manRgh))
        manic.mS = MS_IDL;
      break;

    case MS_JMP :
      if (!manUp(TRUE) || !manUp(TRUE))
        manic.mS = MS_IDL;
      break;

    case  MS_IDL :
      k = manic.mK;
      if (gKey(0, 32) && k != K_RGH && k != K_LFT && k != K_RJMP && k != K_LJMP) {
        /* ak nie je stlaceny shift a nebol posledny klaves pohyb do strany,
          obsluzi sa vynuteny pohyb na pase */
        if (around[1] == 6) {
          manLft(TRUE);
          return TRUE;
        }
        if (around[1] == 5) {
          manRgh(TRUE);
          return TRUE;
        }
      }

      k = testKbd();
      manic.mK = k;
      switch (k) {
        case K_JMP :
          manic.mA = 7;   /* index do tabulky pipania */
          manic.mB = 3;   /* pocitadlo pipania */
          manic.mC = 24;  /* pocitadlo vyskoku */
          manic.mE = 0;   /* status vyskoku do strany */

          if (around[1] == 6) {
            if (manLRJmp(manLft))
              manic.mS = MS_LJMP;
            return TRUE;
          }
          if (around[1] == 5) {
            if (manLRJmp(manRgh))
              manic.mS = MS_RJMP;
            return TRUE;
          }

          manic.mC = 26;  /* pocitadlo vyskoku */
          if (manUp(TRUE)) {
            manic.mS = MS_JMP;
            if (!manUp(TRUE))
              manic.mS = MS_IDL;
          }
          break;

        case K_RJMP :
          manic.mA = 7;   /* index do tabulky pipania */
          manic.mB = 3;   /* pocitadlo pipania */
          manic.mC = 24;  /* pocitadlo vyskoku */
          manic.mE = 0;   /* status vyskoku do strany */
          if (manLRJmp(manRgh))
            manic.mS = MS_RJMP;
          break;

        case K_LJMP :
          manic.mA = 7;   /* index do tabulky pipania */
          manic.mB = 3;   /* pocitadlo pipania */
          manic.mC = 24;  /* pocitadlo vyskoku */
          manic.mE = 0;   /* status vyskoku do strany */
          if (manLRJmp(manLft))
            manic.mS = MS_LJMP;
          break;

        case K_RGH :
          if (manRgh(TRUE))
            manic.mS = MS_RGH;
          break;

        case K_LFT :
          if (manLft(TRUE))
            manic.mS = MS_LFT;
          break;

        case K_NONE :
          manRope();
          break;
      }
      break;
  }

  return TRUE;
}
/* ------------------------------------------------------------------------- */
/* Posun vpravo */
void manRope()
{
  int xx, yy;
  char *p, k;

  manic.mE++;
  if (manic.mE % 4)
    return;

  /* over, ci je Manic na lane */
  xx = manic.mX;
  yy = manic.mY + 15;
  p = manic.pManS + 30;
  k = 0;
  if (manic.mI) {
    k = *p ^ gVramByte(xx, yy);
    if (k != 0 && k != 1 && k != 32) {
      manUp();
      return;
    }
    xx++;
    p++;
  }
  else if (manic.mD) {
    xx++;
    p++;
  }
  if (k != 1 && k != 32 && (!k || !manic.mI)) {
    k = *p ^ gVramByte(xx, yy);
    if (k != 0 && k != 1 && k != 32) {
      manUp();
      return;
    }
    if (!k)
      return;
  }

  xx--;
  yy++;
  if (manic.mI) {
    k = gVramByte(xx, yy);
    if (k != 1 && k != 32)
      return;
  }
  xx++;
  k = gVramByte(xx, yy);
  if (k != 1 && k != 32)
    return;

  gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
  manic.mY++;
  gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if ((manic.mY % TILE_H) == 4)
    calcAround();
}
/* ------------------------------------------------------------------------- */
/* Posun vpravo */
int manRgh(redraw)
  int redraw;
{
  char v;

  if (!manic.mI) {
    /* overenie, ci je pred Manicom prekazka */
    if (manic.mX & 1) {
      v = around[5];
      if (v == 1 || v == 2)
        return FALSE;
      v = around[8];
      if (v == 1 || v == 2)
        return FALSE;
      v = around[11];
      if (v == 1 || v == 2)
        return FALSE;
    }
    else {
      if (around[4] == 3)
        return FALSE;
      if (around[7] == 3)
        return FALSE;
      if (around[10] == 3)
        return FALSE;
    }
  }

  /* skry sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if (manic.mD) {
    /* zmena smeru */
    if (!manic.mI)
      manic.mX++;
    manic.pManS = S_MANIC + (manic.mI * 32);
    manic.mD = 0;
  }
  else {
    manic.mI++;
    if (manic.mI == 4) {
      manic.mI = 0;
      manic.pManS = S_MANIC;
      manic.mX++;
    }
    else
      manic.pManS += 32;
  }

  /* zobraz sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if (!manic.mI)
    calcAround();

  return TRUE;
}
/* ------------------------------------------------------------------------- */
int manLft(redraw)
  int redraw;
{
  char v;

  if (!manic.mI) {
    /* overenie, ci je pred Manicom prekazka */
    if (manic.mX & 1) {
      v = around[3];
      if (v == 1 || v == 3)
        return FALSE;
      v = around[6];
      if (v == 1 || v == 3)
        return FALSE;
      v = around[9];
      if (v == 1 || v == 3)
        return FALSE;
    }
    else {
      if (around[4] == 2)
        return FALSE;
      if (around[7] == 2)
        return FALSE;
      if (around[10] == 2)
        return FALSE;
    }
  }

  /* skry sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if (!manic.mD) {
    /* zmena smeru */
    if (!manic.mI)
      manic.mX--;
    manic.pManS = S_MANIC + 128 + (manic.mI * 32);
    manic.mD = 1;
  }
  else {
    manic.mI++;
    if (manic.mI == 4) {
      manic.mI = 0;
      manic.pManS = S_MANIC + 128;
      manic.mX--;
    }
    else
      manic.pManS += 32;
  }

  /* zobraz sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if (!manic.mI)
    calcAround();

  return TRUE;
}
/* ------------------------------------------------------------------------- */
int manUp(redraw)
  int redraw;
{
  char v;

  /* over, ci je nad Manicom volno */
  if (!manic.mI)
    v = gVramByte(manic.mX + manic.mD, manic.mY - 1);
  else
    v = gVramByte(manic.mX, manic.mY - 1) | gVramByte(manic.mX + 1, manic.mY - 1);
  if (v) {
    /* nieco tam je - pri pevnej podlahe sa vyskok ukonci */
    v = around[13];
    if (v == 1 || v == 2 || v == 3) {
      manFallI();
      return FALSE;
    }
/*
    if ((manic.mX & 1) && manic.mI) {
      v = around[14];
      if (v == 1 || v == 2 || v == 3) {
        manFallI();
        return FALSE;
      }
    }
*/
  } 

  /* skry sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
  manic.mY--;
  /* zobraz sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if ((manic.mY % TILE_H) == 4)
    calcAround();

  /* pipni, ak treba */
  manic.mB--;
  if (!manic.mB) {
    manic.mB = 4;
    v = beepTab[--manic.mA];
    if (v)
      gBeep(v, 4);
    else
      manic.mA = 7;
  }

  /* zniz pocitadlo vysky vyskoku */
  manic.mC--;
  return (manic.mC > 0);
}
/* ------------------------------------------------------------------------- */
int manLRJmp(manMov)
  int (*manMov)();
{
  int xx, yy, ret;
  char *pS;

  ret = TRUE;
  xx = manic.mX;
  yy = manic.mY;
  pS = manic.pManS;   

  switch (manic.mE) {
    case 0 :
      if (!manUp(FALSE) && manic.mC > 0)
        ret = FALSE;
      if (ret && !manUp(FALSE) && manic.mC > 0)
        ret = FALSE;
      (*manMov)(FALSE);
      if (manic.mC == 0)
        manic.mE = 1;
      break;
    
    case 1 :
      (*manMov)(FALSE);
      manic.mE = 2;
      break;

    case 2 :
      if (!manUp(FALSE) && manic.mC > 0)
        ret = FALSE;
      (*manMov)(FALSE);
      manic.mE = 3;
      break;

    case 3 :
      (*manMov)(FALSE);
      manic.mE = 4;
      manic.mA = 1;   /* index do tabulky pipania */
      manic.mB = 3;   /* pocitadlo pipania */
      manic.mC = 11;  /* pocitadlo vysky padu */
      break;

    case 4 :
      manFall(FALSE);
      (*manMov)(FALSE);
      manic.mE = 5;
      break;

    case 5 :
      if (!manFall(FALSE))
        ret = FALSE;
      if (!manFall(FALSE))
        ret = FALSE;
      (*manMov)(FALSE);
      if (!manic.mC) {
        (*manMov)(FALSE);
        manic.mS = MS_FALL;
        manic.mB = 3;   /* pocitadlo pipania */
        manic.mC = 38;  /* pocitadlo vysky padu */
      }
      break;
  }

  if (xx != manic.mX || yy != manic.mY || pS != manic.pManS) {
    gSprite(xx, yy, TILE_W, SPR_H, MODE_NEG, pS);
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
  }

  if (!manic.mI || !(manic.mI % TILE_H))
    calcAround();

  return ret;
}
/* ------------------------------------------------------------------------- */
void manFallI()
{
  /* inicializacia padania Manica */
  manic.mS = MS_FALL;
  manic.mA = 1;   /* index do tabulky pipania */
  manic.mB = 3;   /* pocitadlo pipania */
  manic.mC = 38;  /* pocitadlo vysky padu */
}
/* ------------------------------------------------------------------------- */
int manFall(redraw)
  int redraw;
{
  char k;

  /* znizenie pocitadla vysky padu a reakcia na pad */
  manic.mC--;
  if (!manic.mC)
    return FALSE;

  /* over, ci je pod Manicom volno */
  if (!manic.mI)
    k = gVramByte(manic.mX + manic.mD, manic.mY + SPR_H);
  else
    k = gVramByte(manic.mX, manic.mY + SPR_H) | gVramByte(manic.mX + 1, manic.mY + SPR_H);
  if (k) {
    /* uz nie je */
    if ((manic.mY % TILE_H) == 4)
      calcAround();
    return FALSE;
  }

  /* skry sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
  manic.mY++;
  /* zobraz sprite */
  if (redraw)
    gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);

  if ((manic.mY % TILE_H) == 4)
    calcAround();

  /* pipni, ak treba */
  manic.mB--;
  if (!manic.mB) {
    manic.mB = 4;
    k = beepTab[manic.mA++];
    if (k)
      gBeep(k, 4);
    else
      manic.mA = 1;
  }

  return TRUE;
}
/* ------------------------------------------------------------------------- */
void endGame(fail)
  int fail;
{
  int v;
  char *pR;

  if (fail) {
    /* pipanie a zablikanie Manicom pri kolizii alebo pade */
    for (v = 10; v < 15; v++) {
      gBeep(beepTab[v], 16);
      gSprite(manic.mX, manic.mY, TILE_W, SPR_H, MODE_NEG, manic.pManS);
    }

    /* inverzia hracej plochy */
    gMode(COLOR_0 | MODE_NEG | MODE_INV);
    gFill(ROOM_X, ROOM_Y, ROOM_W * TILE_W, ROOM_H * TILE_H, 0);
  }

  /* male zdrzanie */
  for (v = 0; v < 5000; v++)
    ;

  if (!fail)
    gMelody(pMelody);

  /* vratenie klucov do miestnosti */
  pR = pRoom;
  for (v = 0; v < ROOM_LEN; v++) {
    if (*pR == 99)
      *pR = 9;
    pR++;
  }

  /* vymaz casti obrazovky */
  gMode(COLOR_0 | MODE_SET);
  gFill(ROOM_X, ROOM_Y - 12, ROOM_W * TILE_W, ROOM_H * TILE_H + 12, 0);
}
/* ------------------------------------------------------------------------- */
/*
   Preskumania "okolia" Manica.
   Do pola `around` o velkosti 3x6 sa ukadaju kody dielikov, ktore su na danom
   mieste. Pole sa vyplnuje zdola hore od pozicie 1 dielika pod Manicom.
   Zaroven sa v tejto funkcii osetruje zobratie kluca.
*/
void calcAround()
{
  int c, r, i, j;
  char *pR, *pA;

  c = (manic.mX - ROOM_X) / TILE_W;
  if (manic.mX & 1)
    c += manic.mD;
  c--;
  r = (manic.mY - (ROOM_Y + 2)) / TILE_H + 4; /* pozicia pod Manicom */
  pR = pRoom + r * ROOM_W + c;
  pA = around;

  for (i = 6; i > 0; i--) {
    for (j = 3; j > 0; j--) {
      if (c < 0 || c >= ROOM_W || r < 0 || r >= ROOM_H)
        *pA = 0;
      else {
        if ((*pA = *pR) == 9) {
          /* je to kluc */
          if ((j == 2 && i != 1) || (j == 1 && i == 5)) {
            /* zobratie kluca */
            *pR = 99;
            /* zniz a zobraz pocet klucov */
            prtKeys(TRUE, -1);
            /* vymaz sprite kluca */
            gSprite(c * TILE_W + ROOM_X, r * TILE_H + ROOM_Y, TILE_W, TILE_H, MODE_NEG, S_KEY);
            /* zapiskaj */
            gBeep(-53, 80);
          }
        }
      }
      pA++;
      pR++;
      c++;
    }
    c -= 3;
    r--;
    pR -= 23;
  }
}
/* ------------------------------------------------------------------------- */
/*
  Miestnost ma rozmery 20x30 dielikov.
  Jeden dielik ma velkost 2 znaky na sirku 5 mikroriadkov na vysku.
  Kody dielikov:
    0 - prazdne miesto
    1 - podlaha plna cela
    2 - podlaha plna vlavo
    3 - podlaha plna vpravo
    4 - podlaha porovita
    5 - dielik pohybliveho pasu (vpravo)
    6 - dielik pohybliveho pasu (vlavo)
    7 - dielik pohybliveho pasu
    8 - dielik pohybliveho pasu
    9 - kluc
   10 - rebrik
   11 - schod vlavo
   12 - shod vpravo
   13 - lano
   16 - neviditelna znacka pre urcenie hranic pohybu obludy
  128 - obluda 1
  129 - obluda 2
  130 - obluda 3
  131 - obluda 4
  132 - obluda 5
*/
void drawRoom()
{
  int r, c, xQ, yQ, xW, yW;
  char *pS, *pR, *pRX, z;

  sproCnt = 0;
  sprfCnt = 0;
  pR = pRoom;

  setmem(keysCnt, 2, '0');
  keysCnt[2] = 0;
/*
  setmem(clashCnt, 5, '0');
  clashCnt[5] = 0;
*/

  yQ = ROOM_Y;
  for (r = 0; r < ROOM_H; r++, yQ += TILE_H) {
    xQ = ROOM_X;
    for (c = 0; c < ROOM_W; c++, xQ += TILE_W) {
      z = *pR++;
      if (!z || z == 16)
        continue;
      if (z == 9)
        prtKeys(FALSE, 1);
      if (z == 13) {
        yW = yQ - TILE_H;
        while (!gVramByte(xQ, yW)) {
          gSprite(xQ, yW, TILE_W, TILE_H, MODE_NEG, S_ROPE);
          yW -= TILE_H;
        }
      }
      else if (z < 16) {
        pS = pSprRoom + z * 10;
        gSprite(xQ, yQ, TILE_W, TILE_H, MODE_NEG, pS);
        if (z == 5 || z == 6) {
          feeds[sprfCnt].pFeedS = pS;
          feeds[sprfCnt].fI = (z == 5) ? 0 : 0x81;
          feeds[sprfCnt].fX = xQ;
          feeds[sprfCnt].fY = yQ;
          sprfCnt++;
        }
      }
      else if (sproCnt < MAX_SPRO && z >= 0x80 && z <= 0x84) {
        yW = yQ - 12;
        z &= 0x7F;
        pS = pSprites + 256 + z * 384;
        sprites[sproCnt].pOblD = pS;
        sprites[sproCnt].pOblS = pS;
        sprites[sproCnt].oI = 0;
        sprites[sproCnt].oX = xQ;
        sprites[sproCnt].oY = yW;
        sprites[sproCnt].oD = 0;
        gSprite(xQ, yW, TILE_W, SPR_H, MODE_NEG, pS);

        xW = xQ;
        pRX = pR;
        while (!(z = *pRX) || z >= 0x80) {
          pRX++;
          xW += TILE_W;
        }
        sprites[sproCnt].oXmax = xW;
        do {
          pRX--;
          xW -= TILE_W;
        } while (!(z = *pRX) || z >= 0x80);
        sprites[sproCnt].oXmin = xW + 4;
        sproCnt++;
      }
    }
  }

  prtKeys(TRUE, 0);
/*  prtClash(0); */
}
/* ------------------------------------------------------------------------- */
void prtKeys(prt, id)
  int prt, id;
{
  if (id != 0)
    incDec(keysCnt, 2, id);

  if (prt) {
    gPrintPos(41, 98);
    gPrint(keysCnt);
  }
}
/* ------------------------------------------------------------------------- */
/*
void prtClash(inc)
  int inc;
{
  if (inc > 0)
    incDec(clashCnt, 5, 1);

  gPrintPos(14, 98);
  gPrint(clashCnt);
}
*/
/* ------------------------------------------------------------------------- */
/* Inkrementovanie alebo dekrementovanie 'ASCII' cisla
   n: pointer na cislo
   d: pocet cislic
   i: 0/1=dekrement/increment
*/
void incDec(n, d, i)
  char *n;
  int d, i;
{
  char *p, c;

  p = n + d - 1;
  while (p >= n) {
    c = *p;
    if (i > 0) {
      c++;
      if (c == ':')
        c = '0';
      *p = c;
      if (c != '0')
        break;
    }
    else {
      c--;
      if (c == '/')
        c = '9';
      *p = c;
      if (c != '9')
        break;
    }
    p--;
  }
}
/* ------------------------------------------------------------------------- */
char testKbd()
{
  int k;

  k = gKey(12, 32 + 4); /* shift + sipka vlavo */
  if (!k)
    return K_LJMP;
  if (k == 32)
    return K_LFT;

  k = gKey(14, 32 + 4); /* shift + sipka vpravo */
  if (!k)
    return K_RJMP;
  if (k == 32)
    return K_RGH;
  if (k == 4)
    return K_JMP;

  return K_NONE;
}
/* ------------------------------------------------------------------------- */
