/*
   Demonstracny program ku kniznici SGL pre PMD 85-2A/3 BDS C kompilator.

   Subor: SGLDEMO.C
   Autor: RomBor 09-11/2021
*/

/* ------------------------------------------------------------------------- */
#include <stdio.h>    /* standardna I/O kniznica */
#include <sgl.h>      /* SGL kniznica */
#include "sgldemo.h"  /* hlavickovy subor dema */

/* ------------------------------------------------------------------------- */
void main(argc, argv)
  int argc;
  char **argv;
{
  int v;
  char *pDiaAdr;

  /* inicializacia kniznice */
  v = gInit();

  pDiaFont = NULL;
  pSprites = NULL;
  pSprRoom = NULL;
  pRoom = NULL;
  pMelody = NULL;
  do {
    if (v == 0) {
      /* pre PMD 85-2A nahraj a priprav font s diakritikou */
      if (!allocBuffer(&pDiaFont, DIA_LEN))
        break;
      if (!loadFile(DIA_FILE, pDiaFont, DIA_LEN))
        break;

      /* nastavenie adries fontu s diakritikou do systemovych premennych */
      pDiaAdr = DIAADR;
      v = DIA1;
      *pDiaAdr++ = v;
      *pDiaAdr++ = v >> 8;
      v = DIA2;
      *pDiaAdr++ = v;
      *pDiaAdr = v >> 8;
    }

    /* nahraj a priprav Sprity */
    if (!allocBuffer(&pSprites, SPR_LEN))
      break;
    if (!loadFile(SPR_FILE, pSprites, SPR_LEN))
      break;
    if (!allocBuffer(&pSprRoom, SPR2_LEN))
      break;
    if (!loadFile(SPR2_FILE, pSprRoom, SPR2_LEN))
      break;
    /* nahraj a priprav data miestnosti */
    if (!allocBuffer(&pRoom, ROOM_LEN))
      break;
    if (!loadFile(ROOM_FILE, pRoom, ROOM_LEN))
      break;
    /* nahraj a priprav data melodie */
    if (!allocBuffer(&pMelody, MLDY_LEN))
      break;
    if (!loadFile(MLDY_FILE, pMelody, MLDY_LEN))
      break;

    info();
    krivky();
    hilbert(5);
    game();

  } while (FALSE);

  /* uvolni alokovanu pamat */
  if (pMelody)
    free(pMelody);
  if (pRoom)
    free(pRoom);
  if (pSprRoom)
    free(pSprRoom);
  if (pSprites)
    free(pSprites);
  if (pDiaFont)
    free(pDiaFont);
}
/* ------------------------------------------------------------------------- */
void info()
{
  gOriginY(ORG_Y_TOP);
  gMode(MODE_NEG);
  gCls();

  gMode(COLOR_1 | MODE_NEG);
  gFill(11, 4, 25, 6, 0x2D12);
  gFill(11, 10, 1, 20, 0x2D12);
  gFill(35, 10, 1, 20, 0x2D12);
  gFill(11, 30, 25, 6, 0x2D12);

  gMode(MODE_NEG | DBL_HEIGHT);
  gPrintPos(12, 28);
  gPrint("Simple Graphics Library");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 50);
  gPrint("SGL je jednoduch grafick kninica pre BDS C");
  gPrint("preklada jazyka C, viazan na grafick monosti");
  gPrint("potaov PMD 85-2A alebo PMD 85-3.");

  gMode(COLOR_1 | MODE_NEG);
  gPrintPos(3, 84);
  gPrint("Pre \"iarov\" grafiku je dostupn rozlenie\n");
  gPrint("256x256 bodov, pre Text a \"Spritov\" grafiku je\n");
  gPrint("to 48 znakovch stpcov a 256 mikroriadkov. Pre\n");
  gPrint("sradnicu Y je mon zvoli 3 rzne \"poiatky\".");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 128);
  gPrint("Spsob kreslenia iar a vypisovania reazcov\n");
  gPrint("je mon zvoli podobne ako v BASICu - farbu i\n");
  gPrint("reim. Reazce je mon vypisova s dvojnsobnou");
  gPrint("vkou aj rkou.");

  gMode(COLOR_1 | MODE_NEG);
  gPrintPos(3, 172);
  gPrint("Vzhadom na celoseln povahu BDS C, posky-\n");
  gPrint("tuje kninica iba celoseln variantu goniomet-");
  gPrint("rickch funkci SIN/COS, ktor s svojimi vlast-");
  gPrint("nosami prispsoben grafickmu rozleniu.");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 216);
  gPrint("Mimo funkci pre grafiku poskytuje kninica\n");
  gPrint("aj funkcie pre priamy test klvesnice a pre vy-\n");
  gPrint("ludzovanie jednoduchch tnov a meldie.");

  gMode(COLOR_3 | MODE_NEG);
  gPrintPos(16, 255);
  gPrint("Stlate okovek");

  gInkey(1);

  gMode(COLOR_0 | MODE_SET);
  gFill(0, 40, 48, 200, 0);  /* vymaz casti obrazovky */

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 50);
  gPrint("Pre pouitie kninice vo vlastnch programoch");
  gPrint("je potrebn na hlavn programov disk BDS C na-\n");
  gPrint("koprova tieto sbory SGL kninice:\n");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("SGL.CRL");
  gMode(COLOR_0 | MODE_NEG);
  gPrint(" - relatvny modul kninice\n");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("SGL.H");
  gMode(COLOR_0 | MODE_NEG);
  gPrint("   - hlavikov sbor kninice");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 104);
  gPrint("Do zdrojovho sboru je potrebn na zaiatok\n");
  gPrint("prida vloenie hlavikovho sboru:\n");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("#include <sgl.h>");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 138);
  gPrint("V dvkovom sbore ");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("C.SUB");
  gMode(COLOR_0 | MODE_NEG);
  gPrint(" je treba linkeru ");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("L2\n");
  gMode(COLOR_0 | MODE_NEG);
  gPrint("poveda, aby pouil pri linkovan aj relatvny\n");
  gPrint("modul kninice SGL, napr.\n");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("B:L2 $1 -L B:SGL\n");
  gMode(COLOR_0 | MODE_NEG);
  gPrint("kde sa oakva, e hlavn programov disk je\n");
  gPrint("v mechanike B:.\n");

  gMode(COLOR_0 | MODE_NEG);
  gPrintPos(3, 202);
  gPrint("Popis vetkch funkci je uveden v hlavi-\n");
  gPrint("kovom sbore ");
  gMode(COLOR_1 | MODE_NEG);
  gPrint("SGL.H");
  gMode(COLOR_0 | MODE_NEG);
  gPrint(" a ukka ich pouitia je v\n");
  gPrint("zdrojovch sboroch tohto demontranho prog-\nramu.");

  gInkey(1);
}
/* ------------------------------------------------------------------------- */
void krivky()
{
  int i, j, k, l, m, n;

  gMode(MODE_SET);
  gCls();

  /* ramiky */
  for (j = 12; j <= 92; j += 80) {
    for (i = 12; i < 204; i += 80) {
      gMove(i, j);
      gDraw(i + 71, j);
      gDraw(i + 71, j + 71);
      gDraw(i, j + 71);
      gDraw(i, j);
    }
  }

  /* SGL DEMO */
  gMode(COLOR_3 | MODE_NEG | DBL_HEIGHT | DBL_WIDTH);
  gPrintPos(19, 125);
  gPrint("S");
  gPrintPos(22, 125);
  gPrint("G");
  gPrintPos(25, 125);
  gPrint("L");
  gPrintPos(19, 150);
  gPrint("DEMO");

  /* kruznica */
  gMove(gCosDA(0, 4, 16), gSinDA(0, 4, 16));
  for (i = 0; i < 256; i += 2) {
    gDraw(gCosDA(i, 4, 16), gSinDA(i, 4, 16));
  }

  /* hviezdica */
  gMode(COLOR_2 | MODE_SET);
  for (i = 0; i < 128; i += 16) {
    gMove(gCosDA(i, 4, 16), gSinDA(i, 4, 16));
    gDraw(gCosDA(i + 128, 4, 16), gSinDA(i + 128, 4, 16));
  }

  /* kruh */
  gMode(COLOR_1 | MODE_SET);
  for (i = 0; i < 256; i += 2) {
    gMove(128, 48);
    gDraw(gCosDA(i, 4, 96), gSinDA(i, 4, 16));
  }

  /* N-uholnik */
  gMode(COLOR_2 | MODE_SET);
  m = 8;          /* pocet vrcholov */
  n = 256 / m;    /* "uhlova" vzdialenost vrcholov */
  for (i = 0; i < m; i++) {
    k = n * i + 64;
    for (j = i + 1; j <= m; j++) {
      l = n * j + 64;
      gMove(gCosDA(k, 4, 176), gSinDA(k, 4, 16));
      gDraw(gCosDA(l, 4, 176), gSinDA(l, 4, 16));
    }
  }

  /* stvorec - ornament */
  gMode(COLOR_0 | MODE_SET);
  gMove(16, 96);
  for (i = 0; i < 64; i += 8) {
    gDraw(79, i + 95);
    gDraw(79 - i , 159);
    gDraw(16, 159 - i);
    gDraw(i + 16, 95);
  }

  /* Mobiova krivka */
  gMode(COLOR_1 | MODE_SET);
  gMove(176, 128);
  for (i = 0; i <= 256; i += 2) {
    gDraw(gCosDA(5 * i, 4, 176), gSinDA(3 * i, 4, 96));
  }

  /* sinusovky */
  gMove(0, 207);
  gDraw(255, 207);
  k = 0;
  for (j = 0; j <= 3; j++) {
    gMode(j + MODE_SET);
    for (i = 0; i < 256; i += 8) {
      gMove(k, 207);
      gDraw(k, gSinDA(i, 4, 176));
      k = k + 2;
    }
  }

  gInkey(1);
}
/* ------------------------------------------------------------------------- */
void hilbert(n)
  int n;
{
  int i, x, x0, y, y0, h;

  if (n < 1 || n > 7)
    return;

  gOriginY(ORG_Y_BOTTOM);
  gMode(MODE_NEG);
  gCls();

  i = 0;
  h = 256; /* sirka i vyska plochy */
  x0 = h / 2;
  y0 = x0;
  do {
    i = i + 1;
    h = h / 2;
    x0 = x0 + (h / 2);
    y0 = y0 + (h / 2);
    if (i != n)
      continue;

    x = x0;
    y = y0;
    gMove(x, y);
    hilbertA(i, &x, &y, h);
    break;

  } while (i < 7);

  gInkey(1);
}
/* ------------------------------------------------------------------------- */
void hilbertA(n, x, y, h)
  int n, *x, *y, h;
{
  if (n == 0)
    return;

  hilbertD(n - 1, x, y, h);
  *x = *x - h;
  gDraw(*x, *y);

  hilbertA(n - 1, x, y, h);
  *y = *y - h;
  gDraw(*x, *y);

  hilbertA(n - 1, x, y, h);
  *x = *x + h;
  gDraw(*x, *y);

  hilbertB(n - 1, x, y, h);
}
/* ------------------------------------------------------------------------- */
void hilbertB(n, x, y, h)
  int n, *x, *y, h;
{
  if (n == 0)
    return;

  hilbertC(n - 1, x, y, h);
  *y = *y + h;
  gDraw(*x, *y);

  hilbertB(n - 1, x, y, h);
  *x = *x + h;
  gDraw(*x, *y);

  hilbertB(n - 1, x, y, h);
  *y = *y - h;
  gDraw(*x, *y);

  hilbertA(n - 1, x, y, h);
}
/* ------------------------------------------------------------------------- */
void hilbertC(n, x, y, h)
  int n, *x, *y, h;
{
  if (n == 0)
    return;

  hilbertB(n - 1, x, y, h);
  *x = *x + h;
  gDraw(*x, *y);

  hilbertC(n - 1, x, y, h);
  *y = *y + h;
  gDraw(*x, *y);
  
  hilbertC(n - 1, x, y, h);
  *x = *x - h;
  gDraw(*x, *y);

  hilbertD(n - 1, x, y, h);
}
/* ------------------------------------------------------------------------- */
void hilbertD(n, x, y, h)
  int n, *x, *y, h;
{
  if (n == 0)
    return;

  hilbertA(n - 1, x, y, h);
  *y = *y - h;
  gDraw(*x, *y);

  hilbertD(n - 1, x, y, h);
  *x = *x - h;
  gDraw(*x, *y);

  hilbertD(n - 1, x, y, h);
  *y = *y + h;
  gDraw(*x, *y);

  hilbertC(n - 1, x, y, h);
}
/* ------------------------------------------------------------------------- */
int loadFile(fn, buf, size)
  char *fn, *buf;
{
  FILE  *f;
  int rd;

  f = fopen(fn, "rb");
  if (f == NULL) {
    printError("Nopodarilo sa otvori sbor: ", fn);
    return FALSE;
  }

  rd = fread(buf, size, 1, f);
  if (rd != 1)
    printError("Chyba pri tan zo sboru: ", fn);

  fclose(f);

  return (rd == 1);
}
/* ------------------------------------------------------------------------- */
int allocBuffer(ppBuf, size)
  char **ppBuf;
  int size;
{
  if (*ppBuf)
    return TRUE;

  *ppBuf = alloc(size);
  if (*ppBuf)
    return TRUE;

  printError("Chyba pri alokovan pamte!", NULL);
  return FALSE;
}
/* ------------------------------------------------------------------------- */
void printError(txt, fn)
  char *txt, *fn;
{
  gOriginY(ORG_Y_TOP);
  gMode(MODE_NEG);
  gCls();
  gPrintPos(0, 255);
  gPrint(txt);
  if (fn)
    gPrint(fn);
}
/* ------------------------------------------------------------------------- */
